/*
 * ImmediateValueAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _IMMEDIATE_VALUE_ABSTRACTION_HPP_
#define _IMMEDIATE_VALUE_ABSTRACTION_HPP_

#include <abstraction/NaryOperationAbstraction.hpp>
#include <abstraction/ReturnValueOperationAbstraction.hpp>

namespace abstraction {

template < class ReturnType >
class ImmediateValueAbstraction : virtual public NaryOperationAbstraction < >, virtual public ReturnValueOperationAbstraction < ReturnType > {
public:
	ImmediateValueAbstraction ( ReturnType result ) {
		this->setData ( ReturnType ( result ) );
	}

	bool run ( ) override {
		return true;
	}

};

} /* namespace abstraction */

#endif /* _IMMEDIATE_VALUE_ABSTRACTION_HPP_ */
