/*
 * NormalizeAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _NORMALIZE_ABSTRACTION_HPP_
#define _NORMALIZE_ABSTRACTION_HPP_

#include <abstraction/NaryOperationAbstraction.hpp>
#include <abstraction/ReturnValueOperationAbstraction.hpp>

#include <factory/NormalizeFactory.hpp>

namespace abstraction {

template < class ReturnType, class ParamType >
class NormalizeAbstraction : virtual public NaryOperationAbstraction < ParamType && >, virtual public ReturnValueOperationAbstraction < ReturnType > {
public:
	bool run ( ) override {
		std::pair < std::shared_ptr < OperationAbstraction >, bool > & rawParam = std::get < 0 > ( this->getParams ( ) );
		ParamType && param = retrieveValue < ParamType && > ( rawParam.first, rawParam.second );
		this->setData ( factory::NormalizeFactory::normalize ( std::move ( param ) ) );

		return true;
	}

};

} /* namespace abstraction */

#endif /* _NORMALIZE_ABSTRACTION_HPP_ */
