/*
 * ReferenceAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _REFERENCE_ABSTRACTION_HPP_
#define _REFERENCE_ABSTRACTION_HPP_

#include <memory>

#include <abstraction/NaryOperationAbstraction.hpp>
#include <abstraction/ReturnValueOperationAbstraction.hpp>

namespace abstraction {

template < class Type >
class ReferenceAbstraction : virtual public NaryOperationAbstraction < Type & >, virtual public ReturnValueOperationAbstraction < Type * > {
public:
	bool run ( ) override {
		std::pair < std::shared_ptr < OperationAbstraction >, bool > & param = std::get < 0 > ( this->getParams ( ) );
		this->setData ( & retrieveValue < Type & > ( param.first, param.second ) );

		return true;
	}

};

} /* namespace abstraction */

#endif /* _REFERENCE_ABSTRACTION_HPP_ */
