/*
 * ValueOperationAbstraction.cpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#include <abstraction/ReturnValueOperationAbstraction.hpp>

namespace abstraction {

ext::type_index ReturnValueOperationAbstraction < void >::getReturnTypeIndex ( ) const {
	return ext::type_index ( typeid ( void ) );
}

ext::set < abstraction::ParamQualifiers::ParamQualifier > ReturnValueOperationAbstraction < void >::getReturnTypeQualifiers ( ) const {
	return abstraction::ParamQualifiers::paramQualifiers < void > ( );
}

bool ReturnValueOperationAbstraction < void >::evaluated ( ) const {
	return false;
}

std::shared_ptr < abstraction::OperationAbstraction > ReturnValueOperationAbstraction < void >::getVariableOperationAbstraction ( ) {
	throw std::domain_error ( "Cannot create variable of void type" );
}

} /* namespace abstraction */
