/*
 * SetAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _SET_ABSTRACTION_HPP_
#define _SET_ABSTRACTION_HPP_

#include <alib/memory>

#include <abstraction/AnyaryOperationAbstraction.hpp>
#include <abstraction/ReturnValueOperationAbstraction.hpp>

namespace abstraction {

template < class ParamType >
class SetAbstraction : virtual public AnyaryOperationAbstraction < ParamType >, virtual public ReturnValueOperationAbstraction < ext::set < ParamType > > {
public:
	bool run ( ) override {
		ext::set < ParamType > theSet;
		for ( const std::pair < std::shared_ptr < OperationAbstraction >, bool > & param : this->getParams ( ) ) {
			theSet.insert ( abstraction::retrieveValue < ParamType > ( param.first, param.second ) );
		}

		this->setData ( std::move ( theSet ) );

		return true;
	}

};

} /* namespace abstraction */

#endif /* _SET_ABSTRACTION_HPP_ */
