/*
 * ValueInterface.hpp
 *
 *  Created on: 20. 6. 2019
 *	  Author: Jan Travnicek
 */

#ifndef _VALUE_INTERFACE_HPP_
#define _VALUE_INTERFACE_HPP_

#include <alib/typeindex>

#include <abstraction/OperationAbstraction.hpp>

namespace abstraction {

template < class ReturnType >
class ValueInterface : public virtual OperationAbstraction {
public:
	virtual ReturnType && getValue ( ) const = 0;

	virtual bool isConst ( ) const = 0;
	virtual bool isRvalueRef ( ) const = 0;
	virtual bool isLvalueRef ( ) const = 0;
	virtual bool isAutoMove ( ) const = 0;

	ext::type_index getReturnTypeIndex ( ) const override {
		return ext::type_index ( typeid ( ReturnType ) );
	}

};

} /* namespace abstraction */

#endif /* _VALUE_INTERFACE_HPP_ */
