/*
 * VariableOperationAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _VARIABLE_OPERATION_ABSTRACTION_HPP_
#define _VARIABLE_OPERATION_ABSTRACTION_HPP_

#include <alib/memory>

#include <abstraction/NaryOperationAbstraction.hpp>
#include <abstraction/ValueOperationAbstraction.hpp>

namespace abstraction {

template < class Type >
class VariableOperationAbstraction : virtual public NaryOperationAbstraction < Type >, virtual public ValueOperationAbstraction < Type > {
	bool isAutoMove ( ) const override {
		return false;
	}

public:
	bool run ( ) override {
		this->template run_helper < Type > ( []( Type value ) -> Type { return std::forward < Type > ( value ); }, this->getParams ( ) );
		return true;
	}

	std::shared_ptr < abstraction::OperationAbstraction > getVariableOperationAbstraction ( ) override {
		std::shared_ptr < abstraction::OperationAbstraction > res = std::make_shared < abstraction::VariableOperationAbstraction < Type > > ( );
		res->attachInput ( this->getProxyAbstraction ( ), 0, false, false );
		return res;
	}

};

} /* namespace abstraction */

#endif /* _VARIABLE_OPERATION_ABSTRACTION_HPP_ */
