/*
 * Total.cpp
 *
 *  Created on: 20. 9. 2014
 *	  Author: Tomas Pecka
 */

#include "Total.h"
#include <registration/AlgoRegistration.hpp>

namespace {

auto TotalNFA = registration::AbstractRegister < automaton::simplify::Total, automaton::NFA < >, const automaton::NFA < > & > ( automaton::simplify::Total::total, "automaton" ).setDocumentation (
"Makes a finite automaton's transition function total.\n\
\n\
@param automaton automaton to alter\n\
@return an automaton equivalent to @p automaton with total transition function" );

auto TotalDFA = registration::AbstractRegister < automaton::simplify::Total, automaton::DFA < >, const automaton::DFA < > & > ( automaton::simplify::Total::total, "automaton" ).setDocumentation (
"Makes a finite automaton's transition function total.\n\
\n\
@param automaton automaton to alter\n\
@return an automaton equivalent to @p automaton with total transition function" );

} /* namespace */
