#ifndef _CLI_VALUE_STATEMENT_H_
#define _CLI_VALUE_STATEMENT_H_

#include <ast/Statement.h>
#include <abstraction/ImmediateValueAbstraction.hpp>

namespace cli {

class ValueStatement final : public Statement {
	std::unique_ptr < cli::Arg > m_arg;

public:
	ValueStatement ( std::unique_ptr < cli::Arg > arg ) : m_arg ( std::move ( arg ) ) {
	}

	std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & environment ) const override {
		return std::make_shared < abstraction::ImmediateValueAbstraction < std::string > > ( m_arg->eval ( environment ) );
	}

};

} /* namespace cli */

#endif /* _CLI_VALUE_STATEMENT_H_ */
