/*
 * RawReaderAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _RAW_READER_ABSTRACTION_HPP_
#define _RAW_READER_ABSTRACTION_HPP_

#include <abstraction/NaryOperationAbstraction.hpp>
#include <abstraction/ReturnValueOperationAbstraction.hpp>

#include <factory/RawDataFactory.hpp>

namespace abstraction {

template < class ReturnType >
class RawReaderAbstraction : virtual public NaryOperationAbstraction < std::string && >, virtual public ReturnValueOperationAbstraction < ReturnType > {
public:
	bool run ( ) override {
		std::pair < std::shared_ptr < OperationAbstraction >, bool > & param = std::get < 0 > ( this->getParams ( ) );
		this->setData ( factory::RawDataFactory::fromString ( abstraction::retrieveValue < std::string && > ( param.first, param.second ) ) );
		return true;
	}

};

} /* namespace abstraction */

#endif /* _RAW_READER_ABSTRACTION_HPP_ */
