/*
 * XmlComposerAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _XML_COMPOSER_ABSTRACTION_HPP_
#define _XML_COMPOSER_ABSTRACTION_HPP_

#include <abstraction/NaryOperationAbstraction.hpp>
#include <abstraction/ReturnValueOperationAbstraction.hpp>

#include <factory/XmlDataFactory.hpp>

namespace abstraction {

template < class ParamType >
class XmlComposerAbstraction : virtual public NaryOperationAbstraction < const ParamType & >, virtual public ReturnValueOperationAbstraction < ext::deque < sax::Token > > {
public:
	bool run ( ) override {
		std::pair < std::shared_ptr < OperationAbstraction >, bool > & param = std::get < 0 > ( this->getParams ( ) );
		this->setData ( factory::XmlDataFactory::toTokens ( abstraction::retrieveValue < const ParamType & > ( param.first, param.second ) ) );
		return true;
	}

};

} /* namespace abstraction */

#endif /* _XML_COMPOSER_ABSTRACTION_HPP_ */
