/*
 * XmlTokensParserAbstraction.hpp
 *
 *  Created on: 7. 10. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _XML_TOKENS_PARSER_ABSTRACTION_HPP_
#define _XML_TOKENS_PARSER_ABSTRACTION_HPP_

#include <abstraction/NaryOperationAbstraction.hpp>
#include <abstraction/ReturnValueOperationAbstraction.hpp>

#include <sax/SaxParseInterface.h>

namespace abstraction {

class XmlTokensParserAbstraction : virtual public NaryOperationAbstraction < const std::string & >, virtual ReturnValueOperationAbstraction < ext::deque < sax::Token > > {
public:
	bool run ( ) override {
		std::pair < std::shared_ptr < OperationAbstraction >, bool > & param = std::get < 0 > ( this->getParams ( ) );
		this->setData ( sax::SaxParseInterface::parseFile ( abstraction::retrieveValue < const std::string & > ( param.first, param.second ) ) );
		return true;
	}

};

} /* namespace abstraction */

#endif /* _XML_TOKENS_PARSER_ABSTRACTION_HPP_ */
