/*
 * Prompt.cpp
 *
 *  Created on: 20. 7. 2017
 *	  Author: Jan Travnicek
 */

#include "Prompt.h"
#include "ReadlinePromptCompletion.h"
#include "ReadlinePromptHistory.h"

Prompt::Prompt ( cli::Environment environment ) : m_history_file ( std::string ( std::getenv ( "HOME" ) ) + "/.aql_history" ), m_environment ( std::move ( environment ) ) {
	ReadlinePromptHistory::readHistory ( m_history_file );
}

Prompt::~Prompt ( ) {
	ReadlinePromptHistory::writeHistory ( m_history_file );
}

cli::Command::Result Prompt::run ( ) {
	cli::Command::Result state = cli::Command::Result::OK;

	while ( state != cli::Command::Result::QUIT && state != cli::Command::Result::ERROR ) {
		state = execute_line ( ReadlineCharSequence ( ), true );
	}

	return state;
}
